﻿--do return end

local beql = LibStub("AceAddon-3.0"):GetAddon("beql")
local L = LibStub("AceLocale-3.0"):GetLocale("beql")
QuestInfo = LibStub("LibQuestInfo")
--local charlist = AceLibrary("Dewdrop-2.0")
--local filters = AceLibrary("Dewdrop-2.0")

local frames = {}

--local zonekeys = LibStub("LibBabble-Zone-3.0"):GetReverseLookupTable()
--local zonenames = LibStub("LibBabble-Zone-3.0"):GetUnstrictLookupTable()

local NonZoneKeys, NonZoneNames = {}
local QuestDB, Charlist, Questlist = {}, {}, {}

beql.TimeSinceLastUpdate = 0
beql.AniType = ""
local Gamelocale = GetLocale()

--[[
function beql:UpdateInfo()
	for k in pairs(beql.db.global.QuestData) do
		if beql.db.global.QuestData[k].serial then
			local delete = QuestInfo:UpdateQuestData(k, "Q" .. k .. ";" .. beql.db.global.QuestData[k].serial)
			if delete == false then
				for l in pairs(beql.db.global.QuestData[k]) do
					beql.db.global.QuestData[k][l] = nil
				end
				beql.db.global.QuestData[k] = nil
				print(k .. " Delete: " .. tostring(delete))
			end
		end
	end
end--]]

function beql:HistoryInit()
	if QuestInfo then
		QuestInfo.RegisterCallback(beql, "QuestDataUpdate", beql.QuestInfo_QuestUpdate)
		QuestInfo.RegisterCallback(beql, "QuestZoneUpdate", beql.QuestInfo_ZoneUpdate)
		QuestInfo.RegisterCallback(beql, "QuestLoaded", beql.QuestInfo_ZoneUpdate)
	end
--[[
	beql.questhistory = {}
	-- init non zone variables
	NonZoneNames = {
		-- main professions
		PROF_ALCHEMY  = L["Alchemy"],
		PROF_BLACKSMITHING  = L["Blacksmithing"],
		PROF_ENCHANTING  = L["Enchanting"],
		PROF_ENGINEERING  = L["Engineering"],
		PROF_HERBALISM  = L["Herbalism"],
		PROF_INSCRIPTION  = L["Inscription"],
		PROF_JEWELCRAFTING  = L["Jewelcrafting"],
		PROF_LEATHERWORKING  = L["Letherworking"],
		PROF_MINING  = L["Mining"],
		PROF_SKINNING  = L["Skinning"],
		PROF_TAILORING = L["Tailoring"],
		-- secondary professions
		PROF_COOKING  = L["Cooking"],
		PROF_FIRSTAID  = L["First Aid"],
		PROF_FISHING  = L["Fishing"],

		-- periodic events
		SEASONAL_BREWFEST = L["Brewfest"],
		SEASONAL_MIDSUMMER = L["Midsummer"],
		SEASONAL_LUNAR_FESTIVAL = L["Lunar Festival"],--"Mondfest"
		SEASONAL_DARKMOON_FAIRE = L["Darkmoon Faire"],--"Dunkelmond-Jahrmarkt"
		SEASONAL_SEASONAL = L["Seasonal"], --"Saisonbedingt"

		-- other events
		SPECIAL_EPIC = L["Epic"],--"Episch"
		SPECIAL_BATTLEGROUND = L["Battleground"],--"Schlachtfelder"
		SPECIAL_TREASUREMAP = L["Treasure Map"],--"Schatzkarte"
		SPECIAL_SPECIAL = L["Special"],--"Spezial"
		SPECIAL_LEGANDARY = L["Legendary"],--"Legendär"
		SPECIAL_AQWAR = L["Ahn'Qiraj War "],--"Krieg von Ahn'Qiraj"
		SPECIAL_REPUTATION = L["Reputation"], --"Ruf"
		SPECIAL_INVASION = L["Invasion"],--"Invasion der Geißel"
		SPECIAL_TOURNEMENT = L["Tournement"] --"Turnier"
	}
	
	-- classes
	local classnames = {}
	FillLocalizedClassList(classnames)
	for k, v in pairs(classnames) do
		NonZoneNames["CLASS_"..k] = v
	end
	
	for k,v in pairs(NonZoneNames) do
		NonZoneKeys[v] = k
	end

	QuestDB = beql.db.global.QuestDB
	
	frames.MainFrame = beqlHistoryFrame
	beqlHistoryFrameCharlistScrollFrame = beqlHistoryFrameCharlistScrollFrame
	beqlHistoryFrameQuestScrollFrame = beqlHistoryFrameQuestScrollFrame
	
	
	beql.FrameCache.BrowserFrame = frames
	
	do return end
	-- org code
	local nowiam = UnitName("player").."-"..GetRealmName()
	local info = {
		type = 'group',
		args = {},
	}
	local i = 0
	charlist.value = nowiam
	beqlHistoryCharacterList:SetText(string.sub(nowiam,0,string.find(nowiam,"-")-1))	
	for k, v in pairs (beql.db.profile.QuestHistory) do 
		i = i +1
		info.args[i] = {
			type = 'toggle',
			name = k,
			desc = k,
			get = function() if charlist.value == k then return true else return false end end,
			set = function() charlist.value = k beqlHistoryCharacterList:SetText(string.sub(k,0,string.find(k,"-")-1)) beql:HistoryUpdate() end,
		}
	end
	charlist:Register(beqlHistoryCharacterList, 'children', function() charlist:FeedAceOptionsTable(info) end)
	
	filters.value2 = "all"
	beqlHistoryFilterButton:SetText("Show All")
	
	local filterinfo = {
		type = 'group',
		args = {
			all = {
				type = 'toggle',
				name = "Show All",
				desc = "Show All",
				get = function() if filters.value2 == "all" then return true else return false end end,
				set = function() filters.value2 = "all" beqlHistoryFilterButton:SetText("Show All") beql:HistoryUpdate() end,
			},
			completed = {
				type = 'toggle',
				name = "Completed Only",
				desc = "Completed Only",
				get = function() if filters.value2 == "completed" then return true else return false end end,
				set = function() filters.value2 = "completed" beqlHistoryFilterButton:SetText("Completed Only") beql:HistoryUpdate() end,
			},
			notcompleted = {
				type = 'toggle',
				name = "Not Completed Only",
				desc = "Not Completed Only",
				get = function() if filters.value2 == "notcompleted" then return true else return false end end,
				set = function() filters.value2 = "notcompleted" beqlHistoryFilterButton:SetText("Not Completed Only") beql:HistoryUpdate() end,
			},
			daily = {
				type = 'toggle',
				name = "Daily Only",
				desc = "Daily Only",
				get = function() if filters.value2 == "daily" then return true else return false end end,
				set = function() filters.value2 = "daily" beqlHistoryFilterButton:SetText("Daily Only") beql:HistoryUpdate() end,
			},
		},
	}
	filters:Register(beqlHistoryFilterButton, 'children', function() filters:FeedAceOptionsTable(filterinfo) end) --]]
end

--[[
function beql:GetQuestCategoryKey(zonename)
	local keytype, keyname
	-- zone check
	if zonekeys[zonename] then
		return zonekeys[zonename]
	end
	
	-- check non zone key
	if NonZoneKeys[zonename] then
		keyname = NonZoneKeys[zonename]
	end
	
	if keyname then
		keytype = strsplit("_", keyname)
		return keyname, keytype
	else
		if zonename ~= "UNKNOWN" then
			return "UNKNOWN_" .. zonename, "UNKNOWN"
		else
			return "UNKNOWN"
		end
	end
end

function beql:GetQuestCategoryName(zonekeyname)
	if zonenames[zonekeyname] then
		return zonenames[zonekeyname]
	end
	
	if NonZoneNames[zonekeyname] then
		return NonZoneNames[zonekeyname]
	end
	
	if string.gsub(zonekeyname, "UNKNOWN_", "") then
		return string.gsub(zonekeyname, "UNKNOWN_", "")
	end

	return "UNKNOWN"
end


function beql:GetQuestName(qid)
	if not QuestDB then
		return "Error, QuestDB not loaded"
	end
	
	-- send a request on questdb and return the localized name
	if QuestDB[qid] and QuestDB[qid]["Name-" .. Gamelocale] then
		return QuestDB[qid]["Name-" .. Gamelocale]
	end
	
	-- quest is not in questdb, get title from gametooltip
	beqlQuestFindTooltip:ClearLines()
	beqlQuestFindTooltip:SetOwner( UIParent, "ANCHOR_NONE" );
	beqlQuestFindTooltip:SetHyperlink("quest:"..qid)
	--beqlQuestFindTooltip:Show()
	if not beqlQuestFindTooltip.title then
		beqlQuestFindTooltip.title = _G["beqlQuestFindTooltipTextLeft1"]
	end
	
	local questtitle;
	if beqlQuestFindTooltip:NumLines() > 0 then
		questtitle = beqlQuestFindTooltip.title:GetText();
		beqlQuestFindTooltip:Hide()
		if questtitle ~= nil and questtitle ~= "" then
			if not QuestDB[qid] then
				QuestDB[qid] = {}
			end
			QuestDB[qid]["Name-" .. Gamelocale] = questtitle;
			return questtitle;
		end
	end
	
	beqlQuestFindTooltip:Hide()
	return "Quest not in Cache! (Qid:" .. qid .. ")";
	
end
--]]
function beql:DeleteQuestNames()
	if not QuestDB then
		return
	end
	
	for k in pairs(QuestDB) do
		for l in pairs(QuestDB[k]) do
			if string.find(l, "Name-") then
				QuestDB[k][l] = nil
				--print(l .. " - " .. QuestDB[k][l])
			end
		end
	end
end

--[[
function beql:GetZoneforQuestID(qid)
	if not QuestDB or not QuestDB[qid] then
		return false, false
	end
	
	local zonekey, zonename, tmpkey
	
	tmpkey = QuestDB[qid].zone or "UNKNOWN"
	zonename = beql:GetQuestCategoryName(tmpkey)
	zonekey = beql:GetQuestCategoryKey(zonename)
	
	-- new translation found, replace untranslatet keyname with the correc zonekey
	-- Example
	-- tmpkey = UNKNOWN_Erste Hilfe (German First Aid profession
	-- zonekey = PROF_FIRSTAID
	if tmpkey ~= zonekey  and string.gsub(tmpkey, "UNKNOWN_", "") then 
		QuestDB[qid].zone = zonekey
	end
	
	return zonename, zonekey
	
end
--]]

function beql:HistoryToggle()
	if beql.AniType ~= "" then return end
	if beqlHistoryFrame:IsShown() then
		beqlHistoryFrame:SetAlpha(1)
		beqlHistoryFrame:SetScale(1)
		beql.AniType = "FadeIn"
	else
		beqlHistoryFrame:Show()	
		beqlHistoryFrame:SetScale(0.01)
		beqlHistoryFrame:SetAlpha(0)
		beql.AniType = "FadeOut"
		beql:HistoryUpdate()
	end
end

function beql:HistoryAnimate(elapsed)

	if beql.AniType ~= "FadeIn" and beql.AniType ~= "FadeOut" then
		return
	end

	local alpha = 0
	local scale = 0

	beql.TimeSinceLastUpdate = beql.TimeSinceLastUpdate + elapsed

	if (beql.TimeSinceLastUpdate > 0.01) then
	
		if beql.AniType ~= "FadeIn" then
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha + 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale + 0.05
			beqlHistoryFrame:SetAlpha(alpha)
			if scale > 1 then scale = 1 end
			beqlHistoryFrame:SetScale(scale)
			if alpha == 1 or alpha > 1 then
				beqlHistoryFrame:SetAlpha(1)
				beqlHistoryFrame:SetScale(1)
				beqlHistoryFrame:Show()
				beql.AniType = ""
			end
		else
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha - 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale - 0.05			
			beqlHistoryFrame:SetAlpha(alpha)
			if scale < 0.01 then scale = 0.01 end
			beqlHistoryFrame:SetScale(scale)			
			if alpha == 0 or alpha < 0 then
				beqlHistoryFrame:SetAlpha(0)
				beqlHistoryFrame:SetScale(0.01)			
				beqlHistoryFrame:Hide()
				beql.AniType = ""
			end
		end

		beql.TimeSinceLastUpdate = 0
	end

end

--[[
function beql:HistoryScanLog()
	local nowiam = UnitName("player").."-"..GetRealmName()
	local zone
	local questid
	local qtitle, qlevel, qtag
	
	if beql.db.profile.QuestHistory[nowiam] == nil then
		beql.db.profile.QuestHistory[nowiam] = {} 
	end
	
	-- DB
		-- Char-Server
			-- Zone
				-- QuestName
					-- QuestID
					-- QLevel
					-- IsDaily -
					-- Tag
					-- Start Date
					-- Complete Date
					-- Start Pos
					-- Complete Pos
	
	for i, zone in beqlQ:IterZones() do 
		if beql.db.profile.QuestHistory[nowiam][zone] == nil then
			beql.db.profile.QuestHistory[nowiam][zone] = {}
		end
		for i, questid in beqlQ:QuestsByZone(zone) do 
			qtitle, qlevel, qtag = beqlQ:GetQuestById(questid)
			if beql.db.profile.QuestHistory[nowiam][zone][qtitle] == nil then
				beql.db.profile.QuestHistory[nowiam][zone][qtitle] = {}
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Level = qlevel
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartDate = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartPos = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].EndPos = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].EndDate = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].XP = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Rep = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Tag = qtag
				if qtag == "y" then 
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = true
				else
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = false
				end
			end
		end
	end
end
--]]
function beql:HistoryUpdate()

	do return end
	local questIndex
--	local questHistory = beql.db.profile.QuestHistory[charlist.value]
	local questHistory = {1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9,0}
	local i,k,v
	local ListFrame
	local qTag
	local scrolloffset
	local isCollapsed
	local i = 1
	local controli = 0

	FauxScrollFrame_Update(beqlHistoryListScrollFrame,beql:GetHistoryCount(),25,14)
	scrollofset = FauxScrollFrame_GetOffset(beqlHistoryListScrollFrame)
	
	for k, v in pairs (questHistory) do
		-- Print the Zones
		controli = controli + 1
		if controli > scrollofset then
			if i > 25 then 
				break 
			end
			ListFrame = getglobal("beqlQuestHistoryListFrame"..i)
			ListFrame:SetText(k)
--			ListFrame:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
			ListFrame:Show()
			i = i +1
--			if  questHistory[k].Collapsed  then
				ListFrame:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
--			else
--				ListFrame:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
--			end					
		end

		-- Print the Quests in the Zone
		if 1 == 2 and not questHistory[k].Collapsed then
			for j, l in pairs (questHistory[k]) do
				if j ~= "Collapsed" then
					if (filters.value2 == "completed" and questHistory[k][j].EndDate and questHistory[k][j].EndDate ~= 0) 
					or (filters.value2 == "notcompleted" and not questHistory[k][j].EndDate or questHistory[k][j].EndDate == 0)
					or (filters.value2 == "daily" and questHistory[k][j].Tag == "y")
					or (filters.value2 == "all") then
					controli = controli + 1
					if controli > scrollofset then
						
						if i > 25 then 
							break 
						end
						ListFrame = getglobal("beqlQuestHistoryListFrame"..i)
						ListFrame:SetNormalTexture("")
						ListFrame:SetText("")
						if questHistory[k][j].Tag then
							qTag = string.upper(questHistory[k][j].Tag)
						else
							qTag = ""
						end
						ListFrame:SetText("  ["..questHistory[k][j].Level..qTag.."] "..j)
						ListFrame:SetTextColor(GetDifficultyColor(questHistory[k][j].Level).r,GetDifficultyColor(questHistory[k][j].Level).g,GetDifficultyColor(questHistory[k][j].Level).b)
						ListFrame:Show()	
						i = i +1		
						
					end
					end
				end
			end
		end
		
		
	end
	--Clean Up unused ID's
	for j = i, 25 ,1 do
		ListFrame = getglobal("beqlQuestHistoryListFrame"..j)
		ListFrame:Hide()
	end
end

function beql:ShowQuestDescription(name)
	local questHistory = beql.db.profile.QuestHistory[charlist.value]
	local qTag
	
	for k, v in pairs (questHistory) do
		if not questHistory[k].Collapsed then
			for j, l in pairs (questHistory[k]) do
				if j ~= "Collapsed" then
					if questHistory[k][j].Tag then
						qTag = string.upper(questHistory[k][j].Tag)
					else
						qTag = ""
					end			
					if name == "  ["..questHistory[k][j].Level..qTag.."] "..j then
						beql:PopulateDetailData(questHistory[k][j],j)
					end
				end
			end
		end
	end	
end

function beql:PopulateDetailData(QuestData,Name)
	local qTag
	if QuestData.Tag then  
		qTag = string.upper(QuestData.Tag)
	else
		qTag = ""
	end
	beqlHistoryDetailLine1:SetText("Quest Name: "..Name)
	beqlHistoryDetailLine2:SetText("Level: "..QuestData.Level..qTag)
	beqlHistoryDetailLine3:SetText("Start Date: "..QuestData.StartDate)
	beqlHistoryDetailLine4:SetText("Start Position: "..QuestData.StartPos)
	beqlHistoryDetailLine5:SetText("Completed: ")
	beqlHistoryDetailLine6:SetText("End Date: ")
	beqlHistoryDetailLine7:SetText("End Pos: ")
	beqlHistoryDetailLine8:SetText("XP:")
	beqlHistoryDetailLine9:SetText("Rep:")
	beqlHistoryDetailLine10:SetText("")		
	-- Daily
	-- EndDate
	-- EndPos
	-- XP
	-- Rep
	beqlHistoryDetailFrame:Show()
end

function beql:GetHistoryCount()
	do return 30 end

	local questHistory = beql.db.profile.QuestHistory[charlist.value]
	local k,v,j,l
	local n = 0
	for k, v in pairs (questHistory) do
		n = n +1
		if not questHistory[k].Collapsed then
			for j, l in pairs (questHistory[k]) do
				if j ~= "Collapsed" then
					n = n +1
				end
			end
		end
	end
	return n
end

--]]

function Beql_ScrollFrame_Update()
	beql:HistoryUpdate()
end

function beql:EnableHistoryBrowser()
	if beqlHistoryFrame.mode == "Quest" then
		beqlHistoryModeHistory:Disable()
	else
		beqlHistoryModeHistory:Enable()
	end
	beql:UpdateBrwoserCharList()
end

function beql:EnableCharBrowser()
	if beqlHistoryFrame.mode == "Char" then
		beqlHistoryModeCharBrowser:Disable()
	else
		beqlHistoryModeCharBrowser:Enable()
	end
	beql:UpdateBrwoserCharList()
end

function beql:EnablePartyBrowser()
	if beqlHistoryFrame.mode == "Party" then
		beqlHistoryModePartyBrowser:Disable()
	else
		beqlHistoryModePartyBrowser:Enable()
	end
	beql:UpdateBrwoserCharList()
end

function beql:CharQuestLogUpdate()
		local realm
		local buttonheigth = beqlHistoryFrameCharlistScrollFrame.buttons[1]:GetHeight()
		
		if Charlist.Type ~= 'Char' or Charlist.time < time() - 300 then
			if Charlist.Type ~= 'Char' then
				Charlist.CurrentKey = ''
				HybridScrollFrame_SetOffset(beqlHistoryFrameCharlistScrollFrame , 0)
			end
			if (Charlist.DB) then
				-- clean up old data
				for k in pairs(Charlist.DB) do
					Charlist.DB[k] = nil
				end
			else
				Charlist.DB = {}
			end
			
			Charlist.Type = 'Char'
			Charlist.time = time()
			
			-- make a new list
			for k in pairs(beqlDBnew.char) do
				tinsert(Charlist.DB, k)
			end
			
			table.sort(Charlist.DB)
		end
		
		beqlHistoryFrameCharlistScrollFrame.Highlight:Hide()
		
		local i = -HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame) + 1
		for k,v in pairs(Charlist.DB) do
			local keyplayer, _, keyrealm = strsplit(' ',v , 3)
			-- add new realmheader
			if keyrealm ~= realm then
				realm = keyrealm
				if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
					local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
					button:Reset(button)
					button:SetButton(button)
					button:SetText(realm)
					button:Disable()
				end
				i = i + 1
			end
			if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
				local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
				button:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[i])
				button:SetText(keyplayer)
				button.playerkey = v
				
				-- set HighlightFrame
				if v == Charlist.CurrentKey then
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetParent(button)
					beqlHistoryFrameCharlistScrollFrame.Highlight:ClearAllPoints()
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("TOPLEFT",button ,"TOPLEFT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("BOTTOMRIGHT",button ,"BOTTOMRIGHT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:Show()
				end
			end
			i = i + 1
		end
		for j = i, #beqlHistoryFrameCharlistScrollFrame.buttons do
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[j])
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Disable()
		end
		HybridScrollFrame_Update(beqlHistoryFrameCharlistScrollFrame, (i + HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame)-.5)  * buttonheigth, #beqlHistoryFrameCharlistScrollFrame.buttons * buttonheigth);

end

function beql:PartyQuestLogUpdate()
		local realm
		local buttonheigth = beqlHistoryFrameCharlistScrollFrame.buttons[1]:GetHeight()
		
		if Charlist.Type ~= 'Party' or Charlist.time < time() - 300 then
			if Charlist.Type ~= 'Party' then
				Charlist.CurrentKey = ''
				HybridScrollFrame_SetOffset(beqlHistoryFrameCharlistScrollFrame , 0)
			end
			if (Charlist.DB) then
				-- clean up old data
				for k in pairs(Charlist.DB) do
					Charlist.DB[k] = nil
				end
			else
				Charlist.DB = {}
			end
			
			Charlist.Type = 'Party'
			Charlist.time = time()
			
			-- make a new list
			for k in pairs(beqlDBnew.char) do
				--tinsert(Charlist.DB, k)
			end
			
			table.sort(Charlist.DB)
		end
		
		beqlHistoryFrameCharlistScrollFrame.Highlight:Hide()
		
		local i = -HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame) + 1
		for k,v in pairs(Charlist.DB) do
			local keyplayer, _, keyrealm = strsplit(' ',v , 3)
			-- add new realmheader
			if keyrealm ~= realm then
				realm = keyrealm
				if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
					local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
					button:Reset(button)
					button:SetButton(button)
					button:SetText(realm)
					button:Disable()
				end
				i = i + 1
			end
			if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
				local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
				button:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[i])
				button:SetText(keyplayer)
				button.playerkey = v
				
				-- set HighlightFrame
				if v == Charlist.CurrentKey then
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetParent(button)
					beqlHistoryFrameCharlistScrollFrame.Highlight:ClearAllPoints()
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("TOPLEFT",button ,"TOPLEFT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("BOTTOMRIGHT",button ,"BOTTOMRIGHT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:Show()
				end
			end
			i = i + 1
		end
		for j = i, #beqlHistoryFrameCharlistScrollFrame.buttons do
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[j])
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Disable()
		end
		HybridScrollFrame_Update(beqlHistoryFrameCharlistScrollFrame, (i + HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame)-.5)  * buttonheigth, #beqlHistoryFrameCharlistScrollFrame.buttons * buttonheigth);

end

function beql:HistoryLogUpdate()
		local realm
		local buttonheigth = beqlHistoryFrameCharlistScrollFrame.buttons[1]:GetHeight()
		
		if Charlist.Type ~= 'History' or Charlist.time < time() - 300 then
			if Charlist.Type ~= 'History' then
				Charlist.CurrentKey = '';
				HybridScrollFrame_SetOffset(beqlHistoryFrameCharlistScrollFrame , 0)
			end
			if (Charlist.DB) then
				-- clean up old data
				for k in pairs(Charlist.DB) do
					Charlist.DB[k] = nil
				end
			else
				Charlist.DB = {}
			end
			
			Charlist.Type = 'History'
			Charlist.time = time()
			
			-- make a new list
			for k in pairs(beql.db.global.QuestHistoryDB) do
				tinsert(Charlist.DB, k)
			end
			
			table.sort(Charlist.DB)
		end
		
		beqlHistoryFrameCharlistScrollFrame.Highlight:Hide()
		
		local i = -HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame) + 1
		for k,v in pairs(Charlist.DB) do
			local keyrealm, keyfraction, keyplayer = strsplit('_',v , 3)
			-- add new realmheader
			if keyrealm ~= realm then
				realm = keyrealm
				if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
					local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
					button:Reset(button)
					button:SetButton(button)
					button:SetText(realm)
					button:Disable()
				end
				i = i + 1
			end
			if i > 0 and i <= #beqlHistoryFrameCharlistScrollFrame.buttons then
				local button = beqlHistoryFrameCharlistScrollFrame.buttons[i]
				button:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[i])
				button:SetText(keyplayer)
				button.playerkey = v
				
				-- set HighlightFrame
				if v == Charlist.CurrentKey then
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetParent(button)
					beqlHistoryFrameCharlistScrollFrame.Highlight:ClearAllPoints()
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("TOPLEFT",button ,"TOPLEFT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:SetPoint("BOTTOMRIGHT",button ,"BOTTOMRIGHT",0,0)
					beqlHistoryFrameCharlistScrollFrame.Highlight:Show()
				end
			end
			i = i + 1
		end
		for j = i, #beqlHistoryFrameCharlistScrollFrame.buttons do
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Reset(beqlHistoryFrameCharlistScrollFrame.buttons[j])
			beqlHistoryFrameCharlistScrollFrame.buttons[j]:Disable()
		end
		HybridScrollFrame_Update(beqlHistoryFrameCharlistScrollFrame, (i + HybridScrollFrame_GetOffset(beqlHistoryFrameCharlistScrollFrame)-.5)  * buttonheigth, #beqlHistoryFrameCharlistScrollFrame.buttons * buttonheigth);

end

function beql:UpdateBrwoserCharList()
	if not beqlDBnew then
		return
	end
	

	if beqlHistoryFrame.mode == 'Char' then
		beql:CharQuestLogUpdate()
	elseif beqlHistoryFrame.mode == 'Party' then
		beql:PartyQuestLogUpdate()
	else
		beqlHistoryFrame.mode = 'History'
		beql:HistoryLogUpdate()
	end
end

function beql:QuestBrowserShow()
	beql:ClearBrowserQuestList()
	beql:UpdateBrwoserCharList()
end

function beql:UpdateCharQuests(key)
	local buttonheigth = beqlHistoryFrameQuestScrollFrame.buttons[1]:GetHeight()
	if Questlist.Type ~= 'Char' or Questlist.time < time() - 300  or Questlist.PlayerKey ~= key then
		if not Questlist.zonesheader then
			Questlist.zonesheader = {}
		end
		if Questlist.zones then
			for k in pairs(Questlist.zones) do
				Questlist.zones[k] = nil
			end
		else
			Questlist.zones = {}
		end
		
		if Questlist.DB then
			for k in pairs(Questlist.DB) do
				if type(Questlist.DB[k]) == 'table' then
					for l in pairs(Questlist.DB[k]) do
						Questlist.DB[k][l] = nil
					end
				end
				Questlist.DB[k] = nil
			end
		else
			Questlist.DB = {}
		end
		
		Questlist.Type = 'Char'
		Questlist.time = time()
		Questlist.PlayerKey = key
		
		for qid in pairs(beqlDBnew.char[key].questids) do
			local zonekey, zonename 
			zonekey = QuestInfo:GetZonebyQid(qid)
			if not zonekey then
				zonekey = "UNKNOWN"
			end
			zonename = QuestInfo:GetQuestCategoryName(zonekey)
			
			-- add header control
			if not Questlist.zonesheader[zonekey] then
				Questlist.zonesheader[zonekey] = 1
			end
			
			-- create questtable for zones
			if not Questlist.DB[zonekey] then
				Questlist.DB[zonekey] = {}
			end
			
			table.insert(Questlist.DB[zonekey],qid)
			
			-- create zone keytable
			local found
			for k, v in pairs(Questlist.zones) do
				if v == zonename then
					found = true
					break
				end
			end
			
			if not found then
				table.insert(Questlist.zones, zonename)
			end
		end
		
		for k in pairs(Questlist.DB) do
			table.sort(Questlist.DB[k], function(a,b)
				local qa = QuestInfo:GetQuestName(a)
				local qb = QuestInfo:GetQuestName(b)

				if qa == qb then
					return a < b
				else
					return qa < qb
				end
			end)
		end
		
		table.sort(Questlist.zones)
	end
	--print("CharBrowser " .. key)
	
	local i = -HybridScrollFrame_GetOffset(beqlHistoryFrameQuestScrollFrame) + 1
	
	for m = 1, 1 do
	
	for k, zonename in pairs(Questlist.zones) do
		local zonekey = QuestInfo:GetQuestCategoryKey(zonename)
		if i > 0 and i <= #beqlHistoryFrameQuestScrollFrame.buttons then
			local button = beqlHistoryFrameQuestScrollFrame.buttons[i]
			button:Reset()
			button.HeaderKey = zonekey;
			button:SetButton(button)
			button:SetText(zonename)
			if not Questlist.DB[zonekey] then
				print(zonekey .. " _ " .. zonename)
			end
			button.tag:SetText("#".. #Questlist.DB[zonekey])
			if Questlist.zonesheader[zonekey] == 1 then
				button:SetNormalTexture([[Interface\Buttons\UI-PlusButton-UP]])
			end
		end
		i = i + 1
		if Questlist.zonesheader[zonekey] ~= 1 then
			for k, qid in pairs(Questlist.DB[zonekey]) do
				if i > 0 and i <= #beqlHistoryFrameQuestScrollFrame.buttons then
					local button = beqlHistoryFrameQuestScrollFrame.buttons[i]
					button:Reset()
					button:SetText(QuestInfo:GetQuestName(qid))
					button.tag:SetText("qID: " .. qid)
				end
				i = i + 1
			end
		end
	end
	
	end
	
	for j = i, #beqlHistoryFrameQuestScrollFrame.buttons do
		if j > 0 then
			beqlHistoryFrameQuestScrollFrame.buttons[j]:Reset(beqlHistoryFrameQuestScrollFrame.buttons[j])
			beqlHistoryFrameQuestScrollFrame.buttons[j]:Disable()
		end
	end
	HybridScrollFrame_Update(beqlHistoryFrameQuestScrollFrame, (i + HybridScrollFrame_GetOffset(beqlHistoryFrameQuestScrollFrame)-.5)  * buttonheigth, #beqlHistoryFrameQuestScrollFrame.buttons * buttonheigth);

end

function beql:UpdatePatryQuests(key)
	print("PatryBrowser " .. key)
end

function beql:UpdateQuestHistory(key)
	local buttonheigth = beqlHistoryFrameQuestScrollFrame.buttons[1]:GetHeight()
	if Questlist.Type ~= 'History' or Questlist.time < time() - 300  or Questlist.PlayerKey ~= key then
		if not Questlist.zonesheader then
			Questlist.zonesheader = {}
		end
		if Questlist.zones then
			for k in pairs(Questlist.zones) do
				Questlist.zones[k] = nil
			end
		else
			Questlist.zones = {}
		end
		
		if Questlist.DB then
			for k in pairs(Questlist.DB) do
				if type(Questlist.DB[k]) == 'table' then
					for l in pairs(Questlist.DB[k]) do
						Questlist.DB[k][l] = nil
					end
				end
				Questlist.DB[k] = nil
			end
		else
			Questlist.DB = {}
		end
		
		Questlist.Type = 'History'
		Questlist.time = time()
		Questlist.PlayerKey = key
		
		for qid in pairs(beql.db.global.QuestHistoryDB[key]) do
			--print(qid)
			local zonename, zonekey
			if beql.db.global.QuestDB[qid] then
				zonekey = select(2 , beql:GetZoneforQuestID(qid))
			else
				zonekey = "UNKNOWN"
			end
			zonename = beql:GetQuestCategoryName(zonekey)
			
			-- add header control
			if not Questlist.zonesheader[zonekey] then
				Questlist.zonesheader[zonekey] = 1
			end
			
			-- create questtable for zones
			if not Questlist.DB[zonekey] then
				Questlist.DB[zonekey] = {}
			end
			
			table.insert(Questlist.DB[zonekey],qid)
			
			-- create zone keytable
			local found
			for k, v in pairs(Questlist.zones) do
				if v == zonename then
					found = true
					break
				end
			end
			
			if not found then
				table.insert(Questlist.zones, zonename)
			end
		end
		
		for k in pairs(Questlist.DB) do
			table.sort(Questlist.DB[k], function(a,b)
				local qa = beql:GetQuestName(a)
				local qb = beql:GetQuestName(b)

				if qa == qb then
					return a < b
				else
					return qa < qb
				end
			end)
		end
		
		table.sort(Questlist.zones)
	end
	--print("CharBrowser " .. key)
	
	local i = -HybridScrollFrame_GetOffset(beqlHistoryFrameQuestScrollFrame) + 1
	
	for m = 1, 1 do
	
	for k, zonename in pairs(Questlist.zones) do
		local zonekey = beql:GetQuestCategoryKey(zonename)
		if i > 0 and i <= #beqlHistoryFrameQuestScrollFrame.buttons then
			local button = beqlHistoryFrameQuestScrollFrame.buttons[i]
			button:Reset()
			button.HeaderKey = zonekey;
			button:SetButton(button)
			button:SetText(zonename)
			button.tag:SetText("#".. #Questlist.DB[zonekey])
			if Questlist.zonesheader[zonekey] == 1 then
				button:SetNormalTexture([[Interface\Buttons\UI-PlusButton-UP]])
			end
			QuestLogTitleButton_Resize(button)
		end
		i = i + 1
		if Questlist.zonesheader[zonekey] ~= 1 then
			for k, qid in pairs(Questlist.DB[zonekey]) do
				if i > 0 and i <= #beqlHistoryFrameQuestScrollFrame.buttons then
					local button = beqlHistoryFrameQuestScrollFrame.buttons[i]
					button:Reset()
					local level = QuestDB[qid].level or "??"
--					if type(level) == 'number' then
						--local Color = GetQuestDifficultyColor(type(level) == 'number' and level or 1)
						--button.normalText:SetTextColor(Color.r, Color.g, Color.b)
--					end
					button:SetText("[" .. level .. "] " .. beql:GetQuestName(qid))
					button.tag:SetText("qID: " .. qid)
					QuestLogTitleButton_Resize(button)
				end
				i = i + 1
			end
		end
	end
	
	end
	
	for j = i, #beqlHistoryFrameQuestScrollFrame.buttons do
		if j > 0 then
			beqlHistoryFrameQuestScrollFrame.buttons[j]:Reset(beqlHistoryFrameQuestScrollFrame.buttons[j])
			beqlHistoryFrameQuestScrollFrame.buttons[j]:Disable()
		end
	end
	HybridScrollFrame_Update(beqlHistoryFrameQuestScrollFrame, (i + HybridScrollFrame_GetOffset(beqlHistoryFrameQuestScrollFrame)-.5)  * buttonheigth, #beqlHistoryFrameQuestScrollFrame.buttons * buttonheigth);

end

function beql:BrowserCharlistInit(frame)
	HybridScrollFrame_CreateButtons(frame, "beqlHistoryButtonTemplate");
	local width = frame:GetWidth()
	frame.update = function() beql:UpdateBrwoserCharList() end
	
	for i=1, #frame.buttons do
		local button = frame.buttons[i]
		button:SetWidth(width)
		button:SetScript("OnClick", function(button)
			Charlist.CurrentKey = button.playerkey
			beql:UpdateBrwoserCharList()
			beql:UpdateBrowserQuestList()
		end)
		i = i + 1
	end

	local buttonheigth = frame.buttons[1]:GetHeight()
	HybridScrollFrame_Update(frame, #frame.buttons-1 * buttonheigth, #frame.buttons * buttonheigth);
end

function beql:UpdateBrowserQuestList()
	local key = Charlist.CurrentKey
	if beqlHistoryFrame.mode == 'Char' then
		beql:UpdateCharQuests(key)
	elseif beqlHistoryFrame.mode == 'Party' then
		beql:UpdatePatryQuests(key)
	elseif beqlHistoryFrame.mode == 'History' then
		beql:UpdateQuestHistory(key)
	end

end

function beql:ClearBrowserQuestList()
	for i = 1, #beqlHistoryFrameQuestScrollFrame.buttons do
		beqlHistoryFrameQuestScrollFrame.buttons[i]:Reset()
		beqlHistoryFrameQuestScrollFrame.buttons[i]:Disable()
	end
end

function beql:BrowserQuestlistInit(frame)
	HybridScrollFrame_CreateButtons(frame, "beqlHistoryButtonTemplate");
	local width = frame:GetWidth()
	frame.update = function() beql:UpdateBrowserQuestList() end
	
	for i=1, #frame.buttons do
		local button = frame.buttons[i]
		button:Reset()
		button:SetText(button:GetName())
		button:SetWidth(width)
		button:SetScript("OnClick", function(button)
			if button.HeaderKey then
				if Questlist.zonesheader[button.HeaderKey] == 1 then
					Questlist.zonesheader[button.HeaderKey] = 0
				else
					Questlist.zonesheader[button.HeaderKey] = 1
				end
				beql:UpdateBrowserQuestList()
			end
		end)
	end
	
	local buttonheigth = frame.buttons[1]:GetHeight()
	HybridScrollFrame_Update(frame, #frame.buttons-1 * buttonheigth, #frame.buttons * buttonheigth);

end

function beql:LoadHistoryButton(button)
	button:SetText(button:GetName())
	button.tag:Show()
	button.groupMates:Show()
	button.Reset = function(button)
		button:Enable()
		button:SetText("")
		button.tag:SetText("")
		button.groupMates:SetText("")
		button:SetNormalTexture("")
		button:SetHighlightTexture("")
		button:SetNormalFontObject(GameFontNormalLeft)
		button.HeaderKey = nil
		button.qID = nil
	end
	button.SetButton = function(button)
		button:SetNormalFontObject(GameFontHighlight)
		button:SetNormalTexture([[Interface\Buttons\UI-MinusButton-UP]])
		button:SetHighlightTexture([[Interface\Buttons\UI-PlusButton-Hilight]])
	end
end


function beql:QuestInfo_QuestUpdate(qid, data)
	print("Update " .. qid .. " Data: '" .. data .. "'")
	if not beql.db.global.QuestStrings then
		beql.db.global.QuestStrings = {}
	end
	
	if not beql.db.global.QuestStrings[ceil(qid/100)] then
		beql.db.global.QuestStrings[ceil(qid/100)] = "|" .. data
	else
		beql.db.global.QuestStrings[ceil(qid/100)] = beql.db.global.QuestStrings[ceil(qid/100)] .. data
	end
	
	--print(...)
end

function beql:QuestInfo_ZoneUpdate(qid, zonekey)
	if not beql.db.global.QuestZones then
		beql.db.global.QuestZones = {}
	end
	
	if not beql.db.global.QuestZones[zonekey] then
		beql.db.global.QuestZones[zonekey] = {qid}
	else
		for k in ipairs(beql.db.global.QuestZones[zonekey]) do
			if beql.db.global.QuestZones[zonekey][k] == qid then
				return
			end
		end
		table.insert(beql.db.global.QuestZones[zonekey], qid)
	end
	--print(...)
end

--[[		local questfindframe = CreateFrame("Frame", "beqlQuestFindFrame")
		questfindframe:ClearAllPoints()
		questfindframe:SetPoint("BOTTOMLEFT", MinimapCluster, "BOTTOMLEFT",0,-10)
		questfindframe:SetHeight(20)
		questfindframe:SetWidth(120)
		questfindframe.text = questfindframe:CreateFontString("beqlQuestFindFrameText","BACKGROUND","GameFontNormal")
		local fontname = questfindframe.text:GetFont()
		questfindframe.text:SetFont(fontname,8)
		
		questfindframe.text:SetPoint("LEFT",10,1)
		questfindframe.text:SetText("QuestID: " .. beql.db.global.searchid)

		questfindframe.text:Show()
		questfindframe.id = 1
		questfindframe.questnames = {}
		questfindframe.updatetime = 1
		questfindframe:SetScript("OnUpdate", function(self, elapsed)
			local tooltip = _G["LibQuestInfoTooltip"]
			
			if not tooltip then return end
			
			self.updatetime = self.updatetime - elapsed
			if not tooltip.lines then
				tooltip.lines = {}
				tooltip.lines.left = {}
				tooltip.lines.right = {}
			end
			
			if not tooltip.lines.left[1] then
				tooltip.lines.left[1] = _G["LibQuestInfoTooltipTextLeft1"]
			end
			
--			if tooltip:NumLines() > 0 and self.updatetime > .11 then
--				self.updatetime = .1
--			end
			
			if self.updatetime > 0 then
				if tooltip.lines.left[1]:GetText() == nil and beql.ttqsearch then
					tooltip:ClearLines()
					tooltip:SetOwner( WorldFrame, "ANCHOR_BOTTOMRIGHT" );
					tooltip:SetHyperlink("quest:"..beql.ttqsearch)
					tooltip:Show()
				end
				return
			end
			
			if #beql.db.global.questsearch > -10 then
				--self:Hide()
			end
			
			self.updatetime = .25

			local questtitle = tooltip.lines.left[1]:GetText()
			for k, qdata in pairs(beql.db.global.questsearch) do
				if questtitle ~= nil and qdata.questname == questtitle then
					print("found a quest " .. tostring(questtitle) .. " Id: " .. beql.db.global.searchid)
				end
			end

			beql.db.global.qnames[beql.db.global.searchid] = questtitle
			
			if not beql.db.global.QuestData then
				beql.db.global.QuestData = {}
			end
			
			if questtitle ~= nil then 
				if not beql.db.global.QuestData[beql.db.global.searchid] then
					beql.db.global.QuestData[beql.db.global.searchid] = {}
				end
				
				if strmatch(questtitle, '<') 
				or strmatch(questtitle, '<TXT>') -- placeholder
				or strmatch(strlower(questtitle), 'nyi') -- not implemented yet
				or strmatch(strlower(questtitle), 'unused') -- unused quests
				or strmatch(strlower(questtitle), 'reuse') then -- reused quests
					-- this quests seemes not to be active
					beql.db.global.QuestData[beql.db.global.searchid].zone = "nyi"
				elseif not beql.db.global.QuestData[beql.db.global.searchid].zone then
					beql.db.global.QuestData[beql.db.global.searchid].zone = ""
				end
				if not beql.db.global.QuestData[beql.db.global.searchid].lvl then
					beql.db.global.QuestData[beql.db.global.searchid].lvl = 0
				end
				
				if not beql.db.global.QuestData[beql.db.global.searchid].O then
					beql.db.global.QuestData[beql.db.global.searchid].O = 0
				end
				
				
				for i=2, tooltip:NumLines() do
					if not tooltip.lines.left[i] then
						tooltip.lines.left[i] = _G["LibQuestInfoTooltipTextLeft" .. i]
					end
					
					if tooltip.lines.left[i]:GetText() == QUEST_TOOLTIP_REQUIREMENTS then
						--print("Quest ".. beql.db.global.searchid .. " has "..(tooltip:NumLines()-i).." objectives")
						beql.db.global.QuestData[beql.db.global.searchid].O = tooltip:NumLines()-i
						local l = i
						for j = i+1, tooltip:NumLines() do
							if not tooltip.lines.left[j] then
								tooltip.lines.left[j] = _G["LibQuestInfoTooltipTextLeft" .. j]
							end
							
							local objecttext = tooltip.lines.left[j]:GetText()
							local objectshorttext = objecttext:sub(4,4)
							
							if #objecttext == 4 and (objectshorttext == "I" or objectshorttext == "R" or objectshorttext == "P" or objectshorttext == "M" or objectshorttext == "O" )then
								beql.db.global.QuestData[beql.db.global.searchid]["o" .. (j-l)] = objectshorttext;
							else
								beql.db.global.QuestData[beql.db.global.searchid]["o" .. (j-l)] = "E";
							end
						end
						break;
					end
				end
			end

			local oldid = beql.db.global.searchid
			for i= beql.db.global.searchid + 1, 26204 do
				if beql.db.global.qnames[i] == nil or beql.db.global.qnames[i] ~= nil then
					beql.db.global.searchid = i
					beql.ttqsearch = i
					-- tag bad quest before client crash
					beql.db.global.qnames[i] = "evil"
					break
				end
			end
			if beql.db.global.searchid == oldid then
				beql.db.global.searchid = 1
			end
					
			self.text:SetText("QuestID: " .. beql.db.global.searchid)
			tooltip:ClearLines()
			tooltip:SetOwner( WorldFrame, "ANCHOR_BOTTOMRIGHT" );
			tooltip:SetHyperlink("quest:"..beql.db.global.searchid)
			tooltip:Show()
		end)
--]]

--[[		local QuestLogPartyQuestButton = CreateFrame("Button", "QuestLogPartyQuestButton", QuestLogFrame,"UIPanelButtonTemplate")
		if not beql.debug then
			QuestLogPartyQuestButton:Hide() -- unfinished buisiness
		end
		QuestLogPartyQuestButton:SetWidth(125)
		QuestLogPartyQuestButton:SetHeight(21)
		
		QuestLogPartyQuestButton:SetText("Show Party Quests")
		QuestLogPartyQuestButton:ClearAllPoints()
		QuestLogPartyQuestButton:SetPoint("TOPRIGHT", QuestLogFrameCancelButton, "TOPLEFT", -120,0)
		QuestLogPartyQuestButton:SetScript("OnClick", function() 
			if QuestLogPartyQuestFrame:IsVisible() then
				QuestLogPartyQuestFrame:Hide()
				QuestLogScrollFrame:Show()
				QuestLogPartyQuestButton:SetText("Show Party Quests")
			else
				if not QuestLogPartyQuestFrame.buttons then
					-- first time open Questbrowser, create the buttons
					HybridScrollFrame_CreateButtons(QuestLogPartyQuestFrame, "QuestLogTitleButtonTemplate");
					
					local buttonheigth = QuestLogPartyQuestFrame.buttons[1]:GetHeight()
					
					HybridScrollFrame_Update(QuestLogPartyQuestFrame, 0 * buttonheigth, #QuestLogPartyQuestFrame.buttons * buttonheigth);
					
					for i=1, #QuestLogPartyQuestFrame.buttons do
				--		QuestLogPartyQuestFrame.buttons[i]:Hide()
						QuestLogPartyQuestFrame.buttons[i]:SetScript("OnEnter", function(self) beql:ShowPartyTooltip(self:GetID(), self) end)
						QuestLogPartyQuestFrame.buttons[i]:SetScript("OnClick", function(self)
							if beql.db.global.addonmsg[self.key] == 0 then
								beql.db.global.addonmsg[self.key] = 1 
							else
								beql.db.global.addonmsg[self.key] = 0
							end
							beql:Party_frame_Update()
						end)
						QuestLogPartyQuestFrame.buttons[i]:SetScript("OnLeave", function(self) GameTooltip:FadeOut() end)
						QuestLogPartyQuestFrame.buttons[i].isHeader = true
						QuestLogPartyQuestFrame.buttons[i]:SetNormalTexture("");
						QuestLogPartyQuestFrame.buttons[i]:SetHighlightTexture("");
					end
				end
				
				beql:Party_frame_Update()
				QuestLogPartyQuestFrame:Show()
				QuestLogScrollFrame:Hide()
				QuestLogPartyQuestButton:SetText("Hide Party Quests")
			end
		end)
		
		
		CreateFrame("ScrollFrame", "QuestLogPartyQuestFrame", QuestLogFrame, "HybridScrollFrameTemplate")
		CreateFrame("Slider", "QuestLogPartyQuestFrameScrollBar", QuestLogPartyQuestFrame, "HybridScrollBarTemplate")
		QuestLogPartyQuestFrame:SetAllPoints(QuestLogScrollFrame)
		QuestLogPartyQuestFrame.update = function() beql:Party_frame_Update() end
		QuestLogPartyQuestFrame:Hide()
--		QuestLogPartyQuestFrame:SetBackdrop({
--			bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
--			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
--			insets = { left= 4, right = 4, top = 4, bottom = 4 }
--		})--]]
	

-- EOF --

